Package org.codehaus.plexus.util.xml

## Class XmlStreamReader

- java.lang.Object
- - java.io.Reader
  - - org.codehaus.plexus.util.xml.XmlReader
    - - org.codehaus.plexus.util.xml.XmlStreamReader

All Implemented Interfaces:
  `java.io.Closeable`, `java.lang.AutoCloseable`, `java.lang.Readable`

    public class XmlStreamReader
    extends XmlReader

Character stream that handles (or at least attempts to) all the necessary Voodo to figure out the charset encoding of the XML document within the stream.

IMPORTANT: This class is not related in any way to the org.xml.sax.XMLReader. This one IS a character stream.

All this has to be done without consuming characters from the stream, if not the XML parser will not recognized the document as a valid XML. This is not 100% true, but it's close enough (UTF-8 BOM is not handled by all parsers right now, XmlReader handles it and things work in all parsers).

The XmlReader class handles the charset encoding of XML documents in Files, raw streams and HTTP streams by offering a wide set of constructors.

By default the charset encoding detection is lenient, the constructor with the lenient flag can be used for an script (following HTTP MIME and XML specifications). All this is nicely explained by Mark Pilgrim in his blog, Determining the character encoding of a feed.

Since:
  1.4.4
Version:
  revision 1.17 taken on 26/06/2007 from Rome (see https://rome.dev.java.net/source/browse/rome/src/java/com/sun/syndication/io/XmlReader.java)
Author:
  Alejandro Abdelnur

### Field Summary

### Fields inherited from class java.io.Reader

`lock`

### Constructor Summary

Constructors
`XmlStreamReader​(java.io.File file)` Creates a Reader for a File.
`XmlStreamReader​(java.io.InputStream is)` Creates a Reader for a raw InputStream.
`XmlStreamReader​(java.io.InputStream is, boolean lenient)` Creates a Reader for a raw InputStream.
`XmlStreamReader​(java.io.InputStream is, java.lang.String httpContentType)` Creates a Reader using an InputStream an the associated content-type header.
`XmlStreamReader​(java.io.InputStream is, java.lang.String httpContentType, boolean lenient)` Creates a Reader using an InputStream an the associated content-type header.
`XmlStreamReader​(java.io.InputStream is, java.lang.String httpContentType, boolean lenient, java.lang.String defaultEncoding)` Creates a Reader using an InputStream an the associated content-type header.
`XmlStreamReader​(java.net.URL url)` Creates a Reader using the InputStream of a URL.
`XmlStreamReader​(java.net.URLConnection conn)` Creates a Reader using the InputStream of a URLConnection.

### Method Summary

### Methods inherited from class org.codehaus.plexus.util.xml.XmlReader

`close, getDefaultEncoding, getEncoding, read, setDefaultEncoding`

### Methods inherited from class java.io.Reader

`mark, markSupported, nullReader, read, read, read, ready, reset, skip, transferTo`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### XmlStreamReader

    public XmlStreamReader​(java.io.File file)
                    throws java.io.IOException

Creates a Reader for a File.

It looks for the UTF-8 BOM first, if none sniffs the XML prolog charset, if this is also missing defaults to UTF-8.

It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

Parameters:
  `file` - File to create a Reader from.
Throws:
  `java.io.IOException` - thrown if there is a problem reading the file.

#### XmlStreamReader

    public XmlStreamReader​(java.io.InputStream is)
                    throws java.io.IOException

Creates a Reader for a raw InputStream.

It follows the same logic used for files.

It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

Parameters:
  `is` - InputStream to create a Reader from.
Throws:
  `java.io.IOException` - thrown if there is a problem reading the stream.

#### XmlStreamReader

    public XmlStreamReader​(java.io.InputStream is,
                           boolean lenient)
                    throws java.io.IOException,
                           XmlStreamReaderException

Creates a Reader for a raw InputStream.

It follows the same logic used for files.

If lenient detection is indicated and the detection above fails as per specifications it then attempts the following:

If the content type was 'text/html' it replaces it with 'text/xml' and tries the detection again.

Else if the XML prolog had a charset encoding that encoding is used.

Else if the content type had a charset encoding that encoding is used.

Else 'UTF-8' is used.

If lenient detection is indicated an XmlStreamReaderException is never thrown.

Parameters:
  `is` - InputStream to create a Reader from.
  `lenient` - indicates if the charset encoding detection should be relaxed.
Throws:
  `java.io.IOException` - thrown if there is a problem reading the stream.
  `XmlStreamReaderException` - thrown if the charset encoding could not be determined according to the specs.

#### XmlStreamReader

    public XmlStreamReader​(java.net.URL url)
                    throws java.io.IOException

Creates a Reader using the InputStream of a URL.

If the URL is not of type HTTP and there is not 'content-type' header in the fetched data it uses the same logic used for Files.

If the URL is a HTTP Url or there is a 'content-type' header in the fetched data it uses the same logic used for an InputStream with content-type.

It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

Parameters:
  `url` - URL to create a Reader from.
Throws:
  `java.io.IOException` - thrown if there is a problem reading the stream of the URL.

#### XmlStreamReader

    public XmlStreamReader​(java.net.URLConnection conn)
                    throws java.io.IOException

Creates a Reader using the InputStream of a URLConnection.

If the URLConnection is not of type HttpURLConnection and there is not 'content-type' header in the fetched data it uses the same logic used for files.

If the URLConnection is a HTTP Url or there is a 'content-type' header in the fetched data it uses the same logic used for an InputStream with content-type.

It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

Parameters:
  `conn` - URLConnection to create a Reader from.
Throws:
  `java.io.IOException` - thrown if there is a problem reading the stream of the URLConnection.

#### XmlStreamReader

    public XmlStreamReader​(java.io.InputStream is,
                           java.lang.String httpContentType)
                    throws java.io.IOException

Creates a Reader using an InputStream an the associated content-type header.

First it checks if the stream has BOM. If there is not BOM checks the content-type encoding. If there is not content-type encoding checks the XML prolog encoding. If there is not XML prolog encoding uses the default encoding mandated by the content-type MIME type.

It does a lenient charset encoding detection, check the constructor with the lenient parameter for details.

Parameters:
  `is` - InputStream to create the reader from.
  `httpContentType` - content-type header to use for the resolution of the charset encoding.
Throws:
  `java.io.IOException` - thrown if there is a problem reading the file.

#### XmlStreamReader

    public XmlStreamReader​(java.io.InputStream is,
                           java.lang.String httpContentType,
                           boolean lenient,
                           java.lang.String defaultEncoding)
                    throws java.io.IOException,
                           XmlStreamReaderException

Creates a Reader using an InputStream an the associated content-type header. This constructor is lenient regarding the encoding detection.

First it checks if the stream has BOM. If there is not BOM checks the content-type encoding. If there is not content-type encoding checks the XML prolog encoding. If there is not XML prolog encoding uses the default encoding mandated by the content-type MIME type.

If lenient detection is indicated and the detection above fails as per specifications it then attempts the following:

If the content type was 'text/html' it replaces it with 'text/xml' and tries the detection again.

Else if the XML prolog had a charset encoding that encoding is used.

Else if the content type had a charset encoding that encoding is used.

Else 'UTF-8' is used.

If lenient detection is indicated an XmlStreamReaderException is never thrown.

Parameters:
  `is` - InputStream to create the reader from.
  `httpContentType` - content-type header to use for the resolution of the charset encoding.
  `lenient` - indicates if the charset encoding detection should be relaxed.
Throws:
  `java.io.IOException` - thrown if there is a problem reading the file.
  `XmlStreamReaderException` - thrown if the charset encoding could not be determined according to the specs.

#### XmlStreamReader

    public XmlStreamReader​(java.io.InputStream is,
                           java.lang.String httpContentType,
                           boolean lenient)
                    throws java.io.IOException,
                           XmlStreamReaderException

Creates a Reader using an InputStream an the associated content-type header. This constructor is lenient regarding the encoding detection.

First it checks if the stream has BOM. If there is not BOM checks the content-type encoding. If there is not content-type encoding checks the XML prolog encoding. If there is not XML prolog encoding uses the default encoding mandated by the content-type MIME type.

If lenient detection is indicated and the detection above fails as per specifications it then attempts the following:

If the content type was 'text/html' it replaces it with 'text/xml' and tries the detection again.

Else if the XML prolog had a charset encoding that encoding is used.

Else if the content type had a charset encoding that encoding is used.

Else 'UTF-8' is used.

If lenient detection is indicated an XmlStreamReaderException is never thrown.

Parameters:
  `is` - InputStream to create the reader from.
  `httpContentType` - content-type header to use for the resolution of the charset encoding.
  `lenient` - indicates if the charset encoding detection should be relaxed.
Throws:
  `java.io.IOException` - thrown if there is a problem reading the file.
  `XmlStreamReaderException` - thrown if the charset encoding could not be determined according to the specs.